function [S] = S_2Gauss(size,rho,m_2,var_2,var_1)
% Creates an homogeneous random Bi Gaussian vector with rho as fraction
% of big components, var_phi as expectation for this gaussian and
% var_phi for it's variance. var_psi is the variance of the small
% components of the produced signal.
% size is the number of components of the original signal

num_non_zero=floor(rho*size);
num_zero=size-num_non_zero;

SS=([randn(1,num_zero).*sqrt(var_1),randn(1,num_non_zero).*sqrt(var_2)+m_2]);
S=SS(randperm(size));

end




